/**************************************************************/
/*                                                            */
/*   Program Name :  timesync                                 */
/*                                                            */
/*      Version:  0.00  2002-07-01                            */
/*                1.00  2002-10-04                            */
/*                                                            */
/*      Copyright (c) 2002 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
/*

 ho|ukah{[h  PoorvO
        iZbg͕ʂ̃\tgōsj
         by T.Kondo 2002.7.1

    点 timesync [period]
          period  \鎞ԁibj
                       ftHg͂PObԕ\

*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/tdsio.h>

int sec2hmss(unsigned int sec, int* hh, int* mm, int* ss);

int sec2hms(unsigned int sec, int* hh, int* mm, int* ss)
{
	//char cbuf[60];
	long int j;
	*hh=sec/3600 ;
       j=sec-*hh*(long)3600;
       *mm=(int)(j/60) ;
	*ss=(int)(j-*mm*(long)60) ;
    return 0;
}

int main(int argc, char **argv)
{
	int fd_in,rv;
	unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
       unsigned int secold, secmax;
	int  yyyy, mm, dd;      // Ԑݒ(timeset)ŗp
	int  h, m, s;           // Ԑݒ(timeset)ŗp
       int counter;
       int i;

	if(argc >= 2){
	   secmax = atoi(*(argv + 1 ));
          if(secmax <= 0) {secmax=10;}
       } else {
          secmax=10;
       }


	fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
	if (fd_in == -1) {
		perror("device open() error ");
		return -1;
	}
	printf("IP-VLBI Board 1PPS Time Sync  (by T.KONDO)\n");

	//1b̐ݒ
	rv = ioctl(fd_in, TDSIO_SYNC_1PPS);
	if (rv == -1) {
		perror("ioctl() 1pps sync failed ");
		return -1;
	}
	printf("1pps sync ok\n");

	time = 0; //Ôߏ
       secold=90000;
       counter=0;

	//foCX玞̎擾 and display while
       do{
	rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
	if (rv == -1) {
		perror("ioctl() time get failed ");
		return -1;
	}
       day=TDS_GET_DAYS(time);
       sec=TDS_GET_SEC(time);
       if (sec!=secold) {
       i=sec2hms(sec,&h,&m,&s);
	//printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
	//printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
 	printf("%03d %02d:%02d:%02d\n\033[A",day,h,m,s);
      counter++;
       }
       secold=sec;
       }while(counter <=secmax);

	printf("\n\n");

}
